function results=fusion(imageA, imageB)

A = imread(imageA);
B = imread(imageB);
C = newcolorim([size(A,2),size(A,1)]);

C{1} = uint8(fusion_gray(A(:,:,1), B(:,:,1)));
C{2} = uint8(fusion_gray(A(:,:,2), B(:,:,2)));
C{3} = uint8(fusion_gray(A(:,:,3), B(:,:,3)));

results = C;

end


function combine=fusion_gray(left, right)

[C1,S1] = wavedec2(left,7,'db4');
[C2,~] = wavedec2(right,7,'db4');

ApproxSize = S1(1,1)*S1(1,2);

% approximations
C = (C1(1:ApproxSize) + C2(1:ApproxSize))/2;

% details
for idx=(ApproxSize+1):length(C1)
    if (abs(C1(idx)) < abs(C2(idx)))
        C(idx) = C2(idx);
    else
        C(idx) = C1(idx);
    end
end

combine = waverec2(C,S1,'db4');

end

