function [approx, detail] = fwt_1d_one_level(signal, low, high)
    len = length(signal);    
    
    if (2^floor(log2(len)) == len)                               
        low_filtered = cconv(signal, low, len);
        approx = low_filtered(1:2:length(signal));
            
        high_filtered = cconv(signal, high, len);
        detail = high_filtered(1:2:length(signal));                          
    else
        disp('Error: input signal has wrong size.');
        approx = NaN;
        detail = NaN;
    end
end